<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>event_route Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284029"></a>event_route Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3></div></div></div><div><p class="copyright">Copyright © 2012 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id268962">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248862">1.1. Overview</a></span></dt><dt><span class="section"><a href="#event-route-parameters">1.2. ROUTE events parameters</a></span></dt><dt><span class="section"><a href="#id249673">1.3. EVENT_ROUTE usage</a></span></dt><dt><span class="section"><a href="#id249703">1.4. EVENT_ROUTE socket syntax</a></span></dt><dt><span class="section"><a href="#id293420">1.5. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id293425">1.5.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id293448">1.5.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id293472">1.6. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id293477">1.6.1. </a></span></dt></dl></dd><dt><span class="section"><a href="#id293485">1.7. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293490">1.7.1. 
		<code class="function">fetch_event_params(pvar_list)</code>
		</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id293956">2. Frequently Asked Questions</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249687">EVENT_ROUTE usage</a></dt><dt>1.2. <a href="#id293621"><code class="function">fetch_event_params</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id268962"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248862"></a>1.1. Overview</h2></div></div></div><p>
		This module provides a simple way for handling different events,
		triggered through the OpenSIPS Event Interface, directly from the OpenSIPS
		script. For a specific event, a special route
		(<span class="emphasis"><em>event_route</em></span>) has to be declared in the script, and
		should contain the code that handles the event. The route is executed by
		the module when the corresponding event is raised by the OpenSIPS Event
		Interface.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="event-route-parameters"></a>1.2. ROUTE events parameters</h2></div></div></div><p>
		In order to retrieve the parameters of an event, the 
		<span class="emphasis"><em>fetch_event_params(pvar_list)</em></span> function is used. It
		receives a single parameter, that consists of a list of parameters names
		(optional) and the pseudo-variable where the values will be stored. The
		grammar is:
		</p><p>
			<span class="emphasis"><em>[ param_name= ] pvar [; [ param_name= ] pvar ]*</em></span>
		</p><p>

		Example:
		</p><pre class="programlisting">
fetch_even_params("$avp(first_param)");
fetch_even_params("ip=$avp(pike_ip)");
fetch_even_params("source=$avp(src);destination=$avp(dst)");
</pre><p>

		If the name of the parameter is not specified, the avp will be populated
		according to the order of the parameters, as exported by the event. The
		following code will populate the <span class="emphasis"><em>$avp(first)</em></span> avp
		with the first parameter of the event, <span class="emphasis"><em>$avp(second)</em></span>
		with the second one and so on.

		</p><p>
			fetch_event_params("$avp(first);$avp(second);$avp(third)");
		</p><p>

		<span class="emphasis"><em>NOTE:</em></span> An event may be triggered within a different event, leading
		to nested processing. This function will retrieve the parameters of the currently processed
		event.
	</p><p>The event name can contain any non-quoted string character, but
		it is recommended to follow the syntax:
		E_<span class="emphasis"><em>MODULE_NAME</em></span>_<span class="emphasis"><em>EXTRA_NAME</em></span>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249673"></a>1.3. EVENT_ROUTE usage</h2></div></div></div><p>
			In order to handle the <span class="emphasis"><em>E_PIKE_BLOCKED</em></span> event,
			the following snippet can be used:

			</p><p>
				</p><div class="example"><a name="id249687"></a><p class="title"><b>Example 1.1. EVENT_ROUTE usage</b></p><div class="example-contents"><pre class="programlisting">
	event_route[E_PIKE_BLOCKED] {
		fetch_event_params("ip=$avp(pike-ip)");
		xlog("IP $avp(pike-ip) has been blocked\n");
	}
					</pre></div></div><p><br class="example-break">
			</p><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249703"></a>1.4. EVENT_ROUTE socket syntax</h2></div></div></div><p>
		As the OpenSIPS Event Interface requires, the <span class="emphasis"><em>event_route</em></span>
		module uses a specific socket syntax:
		</p><p><span class="emphasis"><em>'route:' event_name</em></span></p><p>
	</p><p>
		Example:
		</p><p>
			<span class="emphasis"><em>route:E_PIKE_BLOCKED</em></span>
		</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293420"></a>1.5. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293425"></a>1.5.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293448"></a>1.5.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none</em></span>
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293472"></a>1.6. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"></div><p>
		No parameter exported by this module.
			This module doesn't export any parameter
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293485"></a>1.7. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293490"></a>1.7.1. 
		<code class="function">fetch_event_params(pvar_list)</code>
		</h3></div></div></div><p>
			Retrieves the parameters of the event. For more information, please 
			read <a class="xref" href="#event-route-parameters" title="1.2. ROUTE events parameters">Section 1.2, &#8220;ROUTE events parameters&#8221;</a>.
		</p><p>
			The the pseudo variables list as described in <a class="xref" href="#event-route-parameters" title="1.2. ROUTE events parameters">Section 1.2, &#8220;ROUTE events parameters&#8221;</a>.
		</p><p>
		This function can be used from REQUEST_ROUTE and EVENT_ROUTE.
		</p><div class="example"><a name="id293621"></a><p class="title"><b>Example 1.2. <code class="function">fetch_event_params</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
fetch_even_params("$avp(first_param)"); # fetch the first parameter of an event
fetch_even_params("ip=$avp(pike_ip)");  # fetch the ip parameter
fetch_even_params("source=$avp(src);destination=$avp(dst)"); # fetch the source and destination parameters
...
</pre></div></div><br class="example-break"></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id293956"></a>Chapter 2. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><table border="0" summary="Q and A Set"><col align="left" width="1%"><tbody><tr class="question"><td align="left" valign="top"><a name="id293652"></a><a name="id293654"></a><p><b>2.1.</b></p></td><td align="left" valign="top"><p>Can I declare more routes for handling the same event?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			No, only a single <span class="emphasis"><em>event_route</em></span> can be used for a
			particular event.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id293969"></a><a name="id293972"></a><p><b>2.2.</b></p></td><td align="left" valign="top"><p>Where can I find more about OpenSIPS?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Take a look at <a class="ulink" href="http://www.opensips.org/" target="_top">http://www.opensips.org/</a>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id293997"></a><a name="id294000"></a><p><b>2.3.</b></p></td><td align="left" valign="top"><p>Where can I post a question about this module?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			First at all check if your question was already answered on one of
			our mailing lists: 
		</p><div class="itemizedlist"><ul type="disc"><li><p>User Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/users" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/users</a></p></li><li><p>Developer Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/devel" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/devel</a></p></li></ul></div><p>
			E-mails regarding any stable OpenSIPS release should be sent to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code> and e-mails regarding development versions
			should be sent to <code class="email">&lt;<a class="email" href="mailto:devel@lists.opensips.org">devel@lists.opensips.org</a>&gt;</code>.
		</p><p>
			If you want to keep the mail private, send it to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294019"></a><a name="id294066"></a><p><b>2.4.</b></p></td><td align="left" valign="top"><p>How can I report a bug?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Please follow the guidelines provided at:
			<a class="ulink" href="https://github.com/OpenSIPS/opensips/issues" target="_top">https://github.com/OpenSIPS/opensips/issues</a>.
		</p></td></tr></tbody></table></div></div></div></body></html>
