<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>mi_json Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284029"></a>mi_json Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Stephane</span> <span class="surname">Alnet</span></h3><code class="email">&lt;<a class="email" href="mailto:stephane@shimaore.net">stephane@shimaore.net</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Stephane</span> <span class="surname">Alnet</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 
		<a class="ulink" href="http://shimaore.net" target="_top">shimaore.net</a>
	    </p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Rev$</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id282290">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id278447">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id276065">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id265404">1.2.1. External Libraries or Applications</a></span></dt><dt><span class="section"><a href="#id249367">1.2.2. OpenSIPS Modules</a></span></dt></dl></dd><dt><span class="section"><a href="#id249060">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249065">1.3.1. <code class="varname">mi_json_root</code>(string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id248032">1.4. Exported Functions</a></span></dt><dt><span class="section"><a href="#id249575">1.5. Known issues</a></span></dt><dt><span class="section"><a href="#id249590">1.6. Examples</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248011">Set <code class="varname">mi_json_root</code> parameter</a></dt><dt>1.2. <a href="#id249602">JSON request</a></dt><dt>1.3. <a href="#id249625">JSON request</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id282290"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id278447"></a>1.1. Overview</h2></div></div></div><p>
		This module implements a JSON server that handles GET
		requests and generates JSON responses.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276065"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id265404"></a>1.2.1. External Libraries or Applications</h3></div></div></div><p>None
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249367"></a>1.2.2. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>httpd</em></span> module.</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249060"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249065"></a>1.3.1. <code class="varname">mi_json_root</code>(string)</h3></div></div></div><p>
		Specifies the root path for JSON requests:
		http://[opensips_IP]:[opensips_httpd_port]/[mi_json_root]
		</p><p>
		<span class="emphasis"><em>The default value is "json".</em></span>
		</p><div class="example"><a name="id248011"></a><p class="title"><b>Example 1.1. Set <code class="varname">mi_json_root</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_xmlrpc_ng", "mi_json_root", "opensips_mi_json")
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248032"></a>1.4. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249575"></a>1.5. Known issues</h2></div></div></div><p>
		Commands with large responses (like ul_dump) will fail if the
		configured size of the httpd buffer is to small (or if there
		isn't enough pkg memory configured).
		</p><p>
		Future realeases of the httpd and mi_json modules
		will address this issue.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249590"></a>1.6. Examples</h2></div></div></div><p>
		This is an example showing the JSON format for the
		&#8220;<span class="quote">get_statistics net: uri:</span>&#8221; MI command.
		Notice how the paramaters are comma-separated then URI-encoded.
		</p><div class="example"><a name="id249602"></a><p class="title"><b>Example 1.2. JSON request</b></p><div class="example-contents"><pre class="programlisting">

GET /json/get_statistics?params=net%3A%2Curi%3A HTTP/1.1
Accept: application/json
Host: example.net

HTTP/1.1 200 OK
Content-Length: 49
Content-Type: application/json
Date: Fri, 01 Nov 2013 12:00:00 GMT

["net:waiting_udp = 0", "net:waiting_tcp = 0", "uri:positive checks = 0", "uri:negative_checks = 0"]

</pre></div></div><br class="example-break"><p>
		Here is another example showing the JSON format for the
		&#8220;<span class="quote">ps</span>&#8221; MI command.
		</p><div class="example"><a name="id249625"></a><p class="title"><b>Example 1.3. JSON request</b></p><div class="example-contents"><pre class="programlisting">

GET /json/ps HTTP/1.1
Accept: application/json
Host: example.net

HTTP/1.1 200 OK
Content-Length: 428
Content-Type: application/json
Date: Fri, 01 Nov 2013 12:00:00 GMT

[{"name":"Process", "value":null, "attributes":{"ID": "0", "PID": "7400", "Type": "stand-alone SIP receiver udp:127.0.0.1:5060"}}, {"name":"Process", "value":null, "attributes":{"ID": "1", "PID": "7402", "Type": "HTTPD INADDR_ANY:8888"}}, {"name":"Process", "value":null, "attributes":{"ID": "2", "PID": "7403", "Type": "time_keeper"}}, {"name":"Process", "value":null, "attributes":{"ID": "3", "PID": "7404", "Type": "timer"}}]

</pre></div></div><br class="example-break"></div></div></div></body></html>
