<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>pike Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248473"></a>pike Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div></div></div><div><p class="copyright">Copyright © 2003 FhG FOKUS</p></div><div><p class="copyright">Copyright © 2005-2009 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id281471">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248032">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248005">1.2. How to use</a></span></dt><dt><span class="section"><a href="#id249287">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249293">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249594">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249619">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249625">1.4.1. <code class="varname">sampling_time_unit</code> (integer)</a></span></dt><dt><span class="section"><a href="#id248920">1.4.2. <code class="varname">reqs_density_per_unit</code> (integer)</a></span></dt><dt><span class="section"><a href="#id248957">1.4.3. <code class="varname">remove_latency</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293420">1.4.4. <code class="varname">check_route</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293461">1.4.5. <code class="varname">pike_log_level</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293496">1.5. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293501">1.5.1. 
		<code class="function">pike_check_req()</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id293577">1.6. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293582">1.6.1. 
		<code class="function">pike_list</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id293618">1.7. Exported Events</a></span></dt><dd><dl><dt><span class="section"><a href="#id293624">1.7.1. 
		<code class="function">E_PIKE_BLOCKED</code>
		</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id294185">2. Developer Guide</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248899">Set <code class="varname">sampling_time_unit</code> parameter</a></dt><dt>1.2. <a href="#id248940">Set <code class="varname">reqs_density_per_unit</code> parameter</a></dt><dt>1.3. <a href="#id293404">Set <code class="varname">remove_latency</code> parameter</a></dt><dt>1.4. <a href="#id293443">Set <code class="varname">check_route</code> parameter</a></dt><dt>1.5. <a href="#id293479">Set <code class="varname">pike_log_level</code> parameter</a></dt><dt>1.6. <a href="#id293559"><code class="function">pike_check_req</code> usage</a></dt><dt>2.1. <a href="#id293874">Tree of <acronym class="acronym">IP</acronym> addresses</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id281471"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248032"></a>1.1. Overview</h2></div></div></div><p>
		The module provides a simple mechanism for DOS protection - DOS based
		on floods at network level. The module keeps trace of all (or selected 
		ones) IPs of incoming SIP traffic (as source IP) and blocks the ones 
		that exceeded some limit.
		Works simultaneous for IPv4 and IPv6 addresses.
	</p><p>
		The module does not implement any actions on blocking - it just simply
		reports that there is a high traffic from an IP; what to do, is
		the administator decision (via scripting).
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248005"></a>1.2. How to use</h2></div></div></div><p>
		There are 2 ways of using this module (as detecting flood attacks and
		as taking the right action to limit the impact on the system):
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>manual</em></span> - from routing script you can force
				the check of the source IP of an incoming requests, using
				"pike_check_req" function. Note that this checking works only
				for SIP requests and you can decide (based on scripting logic)
				what source IPs to be monitored and what action to be taken
				when a flood is detected.
			</p></li><li><p>
				<span class="emphasis"><em>automatic</em></span> - the module will install 
				internal hooks to catch all incoming requests and replies (even
				if not well formed from SIP point of view) - more or less the
				module will monitor all incoming packages (from the network) on
				the SIP sockets. Each time the source IP of a package needs to 
				be analyse (to see if trusted or not), the module will run a
				script route - see "check_route" module parameter -, where, 
				based on custom logic, you can decide if that IP needs to be
				monitored for flooding or not. As action, when flood is
				detected, the module will automatically drop the packages.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249287"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249293"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249594"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249619"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249625"></a>1.4.1. <code class="varname">sampling_time_unit</code> (integer)</h3></div></div></div><p>
		Time period used for sampling (or the sampling accuracy ;-) ). The 
		smaller the better, but slower. If you want to detect peaks, use a 
		small one. To limit the access (like total number of requests on a 
		long period of time) to a proxy resource (a gateway for ex), use 
		a bigger value of this parameter.
		</p><p>
		IMPORTANT: a too small value may lead to performance penalties due 
		timer process overloading.
		</p><p>
		<span class="emphasis"><em>
			Default value is 2.
		</em></span>
		</p><div class="example"><a name="id248899"></a><p class="title"><b>Example 1.1. Set <code class="varname">sampling_time_unit</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pike", "sampling_time_unit", 10)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248920"></a>1.4.2. <code class="varname">reqs_density_per_unit</code> (integer)</h3></div></div></div><p>
		How many requests should be allowed per sampling_time_unit before 
		blocking all the incoming request from that IP. Practically, the 
		blocking limit is between ( let's have x=reqs_density_per_unit) x 
		and 3*x for IPv4 addresses and between x and 8*x for ipv6 addresses.
		</p><p>
		<span class="emphasis"><em>
			Default value is 30.
		</em></span>
		</p><div class="example"><a name="id248940"></a><p class="title"><b>Example 1.2. Set <code class="varname">reqs_density_per_unit</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pike", "reqs_density_per_unit", 30)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248957"></a>1.4.3. <code class="varname">remove_latency</code> (integer)</h3></div></div></div><p>
		For how long the IP address will be kept in memory after the last 
		request from that IP address. It's a sort of timeout value.
		</p><p>
		<span class="emphasis"><em>
			Default value is 120.
		</em></span>
		</p><div class="example"><a name="id293404"></a><p class="title"><b>Example 1.3. Set <code class="varname">remove_latency</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pike", "remove_latency", 130)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293420"></a>1.4.4. <code class="varname">check_route</code> (integer)</h3></div></div></div><p>
		The name of the script route to be triggers (in automatic way) when a
		package is received from the network. If you do a "drop" in this route,
		it will indicate to the module that the source IP of the package does
		not need to be monitored. Otherwise, the source IP will be
		automatically monitered.
		</p><p>
		By defining this parameter, the automatic checking mode is enabled.
		</p><p>
		<span class="emphasis"><em>
			Default value is NONE (no auto mode).
		</em></span>
		</p><div class="example"><a name="id293443"></a><p class="title"><b>Example 1.4. Set <code class="varname">check_route</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pike", "check_route", "pike")
...
route[pike]{
    if (src_ip==111.222.111.222)  /*trusted, do not check it*/
        drop;
    /* all other IPs are checked*/
}
....
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293461"></a>1.4.5. <code class="varname">pike_log_level</code> (integer)</h3></div></div></div><p>
		Log level to be used by module to auto report the blocking (only first
		time) and unblocking of IPs detected as source of floods.
		</p><p>
		<span class="emphasis"><em>
			Default value is 1 (L_WARN).
		</em></span>
		</p><div class="example"><a name="id293479"></a><p class="title"><b>Example 1.5. Set <code class="varname">pike_log_level</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pike", "pike_log_level", -1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293496"></a>1.5. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293501"></a>1.5.1. 
		<code class="function">pike_check_req()</code>
		</h3></div></div></div><p>
		Process the source IP of the current request and returns false if 
		the IP was exceeding the blocking limit.
		</p><p>
		Return codes:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>1 (true)</em></span> - IP is not to be blocked or 
				internal error occured.
			</p><div class="warning" style="margin-left: 0.5in; margin-right: 0.5in;"><h3 class="title">Warning</h3>
			IMPORTANT: in case of internal error, the function returns true to
			avoid reporting the current processed IP as blocked.
			</div></li><li><p>
				<span class="emphasis"><em>-1 (false)</em></span> - IP is source of
				flooding, being previously detected
			</p></li><li><p>
				<span class="emphasis"><em>-2 (false)</em></span> - IP is detected as a new 
				source of flooding - first time detection
			</p></li></ul></div><p>
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293559"></a><p class="title"><b>Example 1.6. <code class="function">pike_check_req</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (!pike_check_req()) { exit; };
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293577"></a>1.6. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293582"></a>1.6.1. 
		<code class="function">pike_list</code>
		</h3></div></div></div><p>
		Lists the nodes in the pike tree.
		</p><p>
		Name: <span class="emphasis"><em>pike_list</em></span>
		</p><p>Parameters: <span class="emphasis"><em>none</em></span></p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:pike_list:_reply_fifo_file_
		_empty_line_
		</pre></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293618"></a>1.7. Exported Events</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293624"></a>1.7.1. 
		<code class="function">E_PIKE_BLOCKED</code>
		</h3></div></div></div><p>
			This event is raised when the <span class="emphasis"><em>pike</em></span> module
			decides that an IP should be blocked.
		</p><p>Parameters:</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>ip</em></span> - the IP address that has been blocked.
			</p></li></ul></div></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294185"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
	One single tree (for both IPv4 and IPv6) is used. Each node contains a byte, the <acronym class="acronym">IP</acronym>
	addresses stretching from root to the leafs.
    </p><div class="example"><a name="id293874"></a><p class="title"><b>Example 2.1. Tree of <acronym class="acronym">IP</acronym> addresses</b></p><div class="example-contents"><pre class="programlisting">
	   / 193 - 175 - 132 - 164
tree root /                  \ 142
	  \ 195 - 37 - 78 - 163
	   \ 79 - 134
</pre></div></div><br class="example-break"><p>
	To detect the whole address, step by step, from the root to the leafs, the nodes corresponding
	to each byte of the ip address are expanded. In order to be expended a node has to be hit
	for a given number of times (possible by different addresses; in the previous example, the
	node &#8220;<span class="quote">37</span>&#8221; was expended by the 195.37.78.163 and 195.37.79.134 hits).
    </p><p>
	For 193.175.132.164 with x= reqs_density_per_unit:
    </p><div class="itemizedlist"><ul type="disc"><li><p>
		After first req hits -&gt; the &#8220;<span class="quote">193</span>&#8221; node is built.
	    </p></li><li><p>
		After x more hits, the &#8220;<span class="quote">175</span>&#8221; node is build; the hits of
		&#8220;<span class="quote">193</span>&#8221; node are split between itself and its child--both of them gone
		have x/2.
	    </p></li><li><p>
		And so on for node &#8220;<span class="quote">132</span>&#8221; and &#8220;<span class="quote">164</span>&#8221;.
	    </p></li><li><p>
		Once &#8220;<span class="quote">164</span>&#8221; build the entire address can be found in the
		tree. &#8220;<span class="quote">164</span>&#8221; becomes a leaf. After it will be hit as a leaf for x
		times, it will become &#8220;<span class="quote">RED</span>&#8221; (further request from this address will
		be blocked).
	    </p></li></ul></div><p>
	So, to build and block this address were needed 3*x hits. Now, if reqs start coming from
	193.175.132.142, the first 3 bytes are already in the tree (they are shared with the previous
	address), so I will need only x hits (to build node &#8220;<span class="quote">142</span>&#8221; and to make it
	&#8220;<span class="quote">RED</span>&#8221;) to make this address also to be blocked.  This is the reason for the
	variable number of hits necessary to block an <acronym class="acronym">IP</acronym>.
    </p><p>
	The maximum number of hits to turn an address red are (n is the address's number of bytes):
    </p><p>
	1 (first byte) + x (second byte) + (x / 2) * (n - 2) (for the rest of the bytes) + (n - 1)
	(to turn the node to red).
    </p><p>
	So, for IPv4 (n = 4) will be 3x and for IPv6 (n = 16) will be 9x. The minimum number of hits
	to turn an address red is x.
    </p></div></div></body></html>
