<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Script Helper Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>Script Helper Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Liviu</span> <span class="surname">Chircu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Liviu</span> <span class="surname">Chircu</span></h3></div></div></div><div><p class="copyright">Copyright © 2014 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id269071">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id267979">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284084">1.2. How it works</a></span></dt><dt><span class="section"><a href="#id249301">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249583">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249586">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249613">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#use_dialog">1.4.1. <code class="varname">use_dialog</code> (integer)</a></span></dt><dt><span class="section"><a href="#create_dialog_flags">1.4.2. <code class="varname">create_dialog_flags</code> (string)</a></span></dt><dt><span class="section"><a href="#sequential_route">1.4.3. <code class="varname">sequential_route</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293644">1.5. Known Issues</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248880">Setting <code class="varname">use_dialog</code></a></dt><dt>1.2. <a href="#id248919">Setting <code class="varname">create_dialog_flags</code></a></dt><dt>1.3. <a href="#id293627">Setting <code class="varname">sequential_route</code></a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id269071"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id267979"></a>1.1. Overview</h2></div></div></div><p>
	The purpose of the <span class="bold"><strong>Script Helper module</strong></span>
	is to simplify the scripting process in OpenSIPS when doing basic scenarios.
	At the same time, it is useful to script writers as it contains basic SIP
	routing logic, and thus it allows them to focus more on the particular aspects
	of their OpenSIPS routing code.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284084"></a>1.2. How it works</h2></div></div></div><p>
	By simply loading the module, the following
	<span class="bold"><strong>default logic</strong></span> will be embedded:
	</p><div class="itemizedlist"><ul type="disc"><li><p>
	for initial SIP requests, the module will perform <span class="emphasis"><em>record routing</em></span>
	before running the main <span class="emphasis"><em>request</em></span> route
	</p></li><li><p>
	sequential SIP requests will be transparently handled - the module will perform
	<span class="emphasis"><em>loose routing</em></span>, and the request route will not be run at all
	</p></li></ul></div><p>
	Currently, the module may be further configured to embed the following
	<span class="bold"><strong>optional logic</strong></span>:
	</p><div class="itemizedlist"><ul type="disc"><li><p>
		<span class="emphasis"><em>dialog</em></span> support (dialog module dependency - must be loaded before this module)
	</p></li><li><p>
		an additional route to be run before relaying sequential requests
	</p></li></ul></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249301"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249583"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The following  modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>dialog</em></span> (only if <span class="bold"><strong><a class="xref" href="#use_dialog" title="1.4.1. use_dialog (integer)">use_dialog</a></strong></span> is enabled).
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249586"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249613"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="use_dialog"></a>1.4.1. <code class="varname">use_dialog</code> (integer)</h3></div></div></div><p>
		Enables dialog support. Note that the dialog module must be loaded before
		this module when setting this parameter.
		</p><p>
		Default value is 0 (disabled)
		</p><div class="example"><a name="id248880"></a><p class="title"><b>Example 1.1. Setting <code class="varname">use_dialog</code></b></p><div class="example-contents"><pre class="programlisting">
...
modparam("script_helper", "use_dialog", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="create_dialog_flags"></a>1.4.2. <code class="varname">create_dialog_flags</code> (string)</h3></div></div></div><p>
		Flags used when creating dialogs. For details on these flags, please refer
		to the <span class="emphasis"><em>create_dialog()</em></span> function of the dialog module.
		</p><p>
		Default value is "" (no flags are set)
		</p><div class="example"><a name="id248919"></a><p class="title"><b>Example 1.2. Setting <code class="varname">create_dialog_flags</code></b></p><div class="example-contents"><pre class="programlisting">
...
modparam("script_helper", "create_dialog_flags", "PpB")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="sequential_route"></a>1.4.3. <code class="varname">sequential_route</code> (string)</h3></div></div></div><p>
		Optional route to be run just before sequential requests are relayed.
		If the <span class="emphasis"><em>exit</em></span> script statement is used inside this route,
		the module assumes that the relaying logic has been handled.
		</p><p>
		By default, this parameter is not set
		</p><div class="example"><a name="id293627"></a><p class="title"><b>Example 1.3. Setting <code class="varname">sequential_route</code></b></p><div class="example-contents"><pre class="programlisting">
...
modparam("script_helper", "sequential_route", "sequential_handling")
...
route [sequential_handling]
{
...
}
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293644"></a>1.5. Known Issues</h2></div></div></div><p>
		The Max-Forwards header is currently not handled at all.
	</p></div></div></div></body></html>
